import Designer from './Designer';
import PersistenceManager from './PersistenceManager';
import WidgetManager from './WidgetManager';
/**
 * WebComponent implementation for minplot designer.
 * This component is registered as mindplot-component in customElements api. (see https://developer.mozilla.org/en-US/docs/Web/API/CustomElementRegistry/define)
 * For use it you need to import minplot.js and put in your DOM a <mindplot-component/> tag. In order to create a Designer on it you need to call its buildDesigner method. Maps can be loaded throught loadMap method.
 */
declare class MindplotWebComponent extends HTMLElement {
    private _shadowRoot;
    private _designer;
    private _saveRequired;
    private _isLoaded;
    constructor();
    /**
     * @returns the designer
     */
    getDesigner(): Designer | null;
    /**
     * Build the designer of the component
     * @param {PersistenceManager} persistence the persistence manager to be used. By default a LocalStorageManager is created
     * @param {UIManager} widgetManager an UI Manager to override default Designer option.
     */
    buildDesigner(persistence?: PersistenceManager, widgetManager?: WidgetManager): Designer;
    isLoaded(): boolean;
    private registerShortcuts;
    setSaveRequired(value: boolean): void;
    getSaveRequired(): boolean;
    loadMap(id: string): Promise<void>;
    save(saveHistory: boolean): void;
    unlockMap(): void;
}
export default MindplotWebComponent;
